<template>
  <VuePerfectScrollbar
    class="scroll-area p-4"
    :settings="settings"
    :key="$vs.rtl"
  >
    <form @submit.prevent>
      <!-- Enter Project Name -->
      <vs-input
        v-validate="'required'"
        :name="`project`"
        label-placeholder="Tên dự án"
        v-model="value.name"
        class="w-full mb-4 mt-5"
        :color="isValid ? 'success' : 'danger'"
        @input="updateData('name', $event)"
      />
      <!-- /Enter project Name -->

      <!-- /Enter project description -->
      <label class="vs-input--label">Mô tả</label>
      <vs-textarea
        class="mb-5"
        counter="120"
        maxlength="120"
        :counter-danger.sync="counterDanger"
        v-model="value.description"
        rows="2"
      />
      <!-- /Enter project description -->

      <!-- Select Color -->
      <ColorSelectionDropdown
        :selectedColorId="value.color"
        @onSelectColor="updateData('color', $event)"
      />
      <!-- /Select Color -->

      <!-- Add to favorites -->
      <div class="flex py-5">
        <vs-switch
          class="mr-2"
          v-model="value.isFavorite"
          @input="updateData('isFavorite', $event)"
        />
        <label for="">Thêm vào mục yêu thích</label>
      </div>
      <!-- /Add to favorites -->

      <!-- Select View Type -->
      <div>
        <label class="vs-input--label font-bold">Dạng hiển thị</label>
        <div class="vx-row no-gutter">
          <div class="vx-col sm:w-1/2 w-full">
            <div class="edit_project_modal__list_preview "></div>
            <vs-radio
              v-model="value.viewType"
              :vs-value="0"
              @change="updateData('viewType', 0)"
            >
              Danh sách
            </vs-radio>
          </div>
          <!-- <div class="vx-col sm:w-1/2 w-full">
            <div class="edit_project_modal__board_preview"></div>
            <vs-radio
              v-model="value.viewType"
              :vs-value="1"
              @change="updateData('viewType', 1)"
            >
              Board
            </vs-radio>
          </div> -->
        </div>
      </div>
      <!-- /Select View Type -->
    </form>
  </VuePerfectScrollbar>
</template>

<script>
import ColorSelectionDropdown from "../../components/form-elements/ColorSelectionDropdown.vue";
import VuePerfectScrollbar from "vue-perfect-scrollbar";
import { ViewTypeEnums } from "@/constants/enums.js";

export default {
  name: "project-form",
  components: {
    VuePerfectScrollbar,
    ColorSelectionDropdown
  },
  props: {
    value: { type: Object, default: () => ({}) },
    isValid: { type: Boolean, default: true }
  },
  data() {
    return {
      counterDanger: false,
      settings: {
        maxScrollbarLength: 60,
        wheelSpeed: 0.3
      }
    };
  },
  methods: {
    updateData(field, text) {
      const newData = { ...this.value, [field]: text };
      this.$emit("input", newData);
    }
  }
};
</script>

<style lang="scss">
.edit_project_modal__list_preview {
  background-position: 0 10px;
  background-image: url(https://d3ptyyxy2at9ui.cloudfront.net/assets/images/76bd6d1001a372ece03ef777813b3352.svg);
}
.edit_project_modal__board_preview {
  background-position: 5px 5px;
  background-image: url(https://d3ptyyxy2at9ui.cloudfront.net/assets/images/04587b33fb8e382780f4fb5787663300.svg);
}
.edit_project_modal__list_preview,
.edit_project_modal__board_preview {
  width: 160px;
  height: 120px;
  margin-bottom: 8px;
  border: 1px solid #ddd;
  border-radius: 5px;
  background-repeat: no-repeat;
}
</style>
